Package de.gebit.integrity.parameter.conversion

## Class AbstractModularValueConverter.ConversionKey

- java.lang.Object
- - de.gebit.integrity.parameter.conversion.AbstractModularValueConverter.ConversionKey

- Enclosing class:
    AbstractModularValueConverter

      protected static class AbstractModularValueConverter.ConversionKey
      extends Object

  This class defines a key for efficient searching for conversions in maps.
  Author:
    Rene Schneider - initial API and implementation

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ConversionKey​(Class<?> aSourceType, Class<?> aTargetType)` | Creates a new instance.
    `ConversionKey​(Class<? extends Conversion<?,​?>> aConversion)` | Takes a `Conversion` implementation and determines the applicable conversion key.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(Object anObject)` |
    `List<AbstractModularValueConverter.ConversionKey>` | `generateDerivedKeys()` | Generates the derived conversion keys from the current key.
    `Class<?>` | `getSourceType()` |
    `Class<?>` | `getTargetType()` |
    `int` | `hashCode()` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ConversionKey

          public ConversionKey​(Class<?> aSourceType,
                               Class<?> aTargetType)

      Creates a new instance.
      Parameters:
        `aSourceType` - the source type
        `aTargetType` - the target type

    - #### ConversionKey

          public ConversionKey​(Class<? extends Conversion<?,​?>> aConversion)

      Takes a `Conversion` implementation and determines the applicable conversion key.
      Parameters:
        `aConversion` - the conversion to look at

  - ### Method Detail

    - #### getSourceType

          public Class<?> getSourceType()

    - #### getTargetType

          public Class<?> getTargetType()

    - #### generateDerivedKeys

          public List<AbstractModularValueConverter.ConversionKey> generateDerivedKeys()

      Generates the derived conversion keys from the current key. "Derived keys" means keys which cover the whole target type superclass hierarchy.
      Returns:
        the derived key list

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals​(Object anObject)

      Overrides:
        `equals` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`